"""
www.swissgeo.ch commandline browser interface
"""

import httplib, urllib, string
from types import *
from sys import stderr

def ShowResponse(r, quiet):
  if not quiet:
    stderr.write(str(r.status) + ' ' + r.reason + '\n')

def Karte5(strasse, nummer, plz, ort, zoom=None, quiet=0):
  """
  Liefert die URL des Kartenbildes, oder None.
  Zeigt Debug-Ausgaben an.
  """
  conn = httplib.HTTPConnection('www.swissgeo.ch')
  conn.request('GET', '/main.php')
  r = conn.getresponse()
  ShowResponse(r, quiet)
  data = r.read()
  sessionid = r.getheader('Location').split('=')[1];
  
  # A "real" browser would do this:
  #conn.request('GET', '/main.php?SESSID=' + sessionid)
  #r = conn.getresponse()
  #ShowResponse(r, quiet)
  #data = r.read()
  
  params = urllib.urlencode({'SESSID':sessionid, 'rue':strasse, 'numero':nummer, 'npa':plz, 'localite':ort, 'x':22, 'y':11})
  #params = urllib.urlencode({'SESSID':sessionid, 'rue':strasse, 'numero':nummer, 'x':22, 'y':11})
  headers = {'Content-type': 'application/x-www-form-urlencoded', 'Accept': 'text/plain'}
  conn.request('POST', '/adresse_search.php', params, headers)
  r = conn.getresponse()
  ShowResponse(r, quiet)
  data = r.read()
  if r.status == 302:
    if not quiet:
      stderr.write('Fehler, sorry :(\n')
    #next = r.getheader('Location') 
    #conn.request('GET', '/main.php?SESSID=' + sessionid)
    #r = conn.getresponse()
    #ShowResponse(r, quiet)
    #data = r.read()
  pos = data.find('geomatic')
  if pos == -1:
      # show alternatives
      #print data
      pos = data.find('<tr><td>')
      if not quiet:
        stderr.write('Nichts gefunden. Alternativen:\n')
      while pos != -1:
          pos2 = data.find('</td></tr>', pos)
          substr = data[pos+8:pos2]
          if substr.find('<img src') == -1:
              stderr.write(substr + '\n')
          pos = data.find('<tr><td>', pos + 1)
      conn.close()
      return None
  else:
      if zoom:
        if not quiet:
          stderr.write('Zooming...\n')
        conn.request('GET', '/actions.php?action=zoom&echelle=' + zoom + '&SESSID=' + sessionid)
        r = conn.getresponse()
        ShowResponse(r, quiet)
        data = r.read()
        # get zoomed url
        conn.request('GET', '/adresse_search.php?SESSID=' + sessionid)
        r = conn.getresponse()
        ShowResponse(r, quiet)
        data = r.read()
        # pos might have changed
        pos = data.find('geomatic')

      imageurl = 'http://map.swissgeo.ch/www1_gif/' + data[pos:data.find(' ', pos)]
      conn.close()
      if not quiet:
        stderr.write('OK, habe den Link zum Bild:\n' + imageurl + '\n')
        stderr.write('Die aktive Session:\n')
        stderr.write('http://www.swissgeo.ch/adresse_search.php?SESSID=' + sessionid + '\n')
      return imageurl

def Karte(args, zoom=None, quiet=0):
    """
    Versucht aus args eine Ortsbeschreibung rauszukriegen.
    Liefert die URL des Kartenbildes, oder None.
    Zeigt Debug-Ausgaben an.
    """
    strasse = ''
    nummer = ''
    plz = ''
    ort = ''
    if type(args) is StringType:
        args = args.split(' ')
    if len(args) == 1:
      args = args[0].split(' ')
    if len(args) > 1 and args[1].isdigit():
        strasse, nummer = args[0:2]
        args = args[2:]
    # parse PLZ ORT or ORT or PLZ
    if len(args) > 1:
        plz, ort = args[0:2]
    elif len(args) == 1:
        if args[0].isdigit():
            plz = args.pop()
        else:
            ort = args.pop()
    if strasse and strasse[-1] == '.':
      strasse = strasse[:-1]
    #debug output
    #print "Strasse: " + strasse
    #print "Nummer: " + nummer
    #print "Postleitzahl: " + plz
    #print "Ort: " + ort
    #print "Zoom: " + str(zoom)
    return Karte5(strasse, nummer, plz, ort, zoom, quiet)
